<?php

/*************************************************************
*  TorrentFlux PHP Torrent Manager
*  www.torrentflux.com
**************************************************************/
/*
    This file is part of TorrentFlux.

    TorrentFlux is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    TorrentFlux is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TorrentFlux; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/**************************************************************************/
// YOUR DATABASE CONNECTION INFORMATION
/**************************************************************************/
// Check the adodb/drivers/ directory for support for your database
// you may choose from many (mysql is the default)
$cfg["db_type"] = "mysql";       // mysql, postgres7 view adodb/drivers/
$cfg["db_host"] = "localhost";   // DB host computer name or IP
$cfg["db_name"] = "torrentflux"; // Name of the Database
$cfg["db_user"] = "user";        // username for your MySQL database
$cfg["db_pass"] = "password";    // password for database
/**************************************************************************/

/**************************************************************************/
// Define the PATH where the downloads will go (note that it ends with a / [slash])
// Note this can be anywhere (not where TorrentFlux is installed)
// must be chmod'd to 777 (DO NOT MAKE THIS THE PATH TO YOUR PHP FILES!)
$cfg["path"] = "/usr/local/torrent/";
/**************************************************************************/

/**************************************************************************/
// Specify the path to the btphptornado.py or btphptorrent.py python script
// Only change the path to this file as needed.
// You may use 'btphptornado.py' for BitTornado Client or 'btphptorrent.py'
// for the original BitTorrent Client (read the INSTALL file for more).
$cfg["btphpbin"] = "/usr/local/TF_BitTornado/btphptornado.py";
/**************************************************************************/

/**************************************************************************/
// Specify the btshowmetainfo.py file name
// Use the full path to this file -- change as needed.
$cfg["btshowmetainfo"] = "/usr/local/TF_BitTornado/btshowmetainfo.py";
/**************************************************************************/

// Set advanced_start to true if you want to allow users to use the advanced
// start dialog popup when starting torrents
$cfg["advanced_start"] = true;

// --max_upload_rate - Set the Default Value for the Max Upload Rate Per Torrent
$cfg["max_upload_rate"] = "10";  // KB/second  max upload rate for each torrent

// --max_download_rate - Set the Default Value for the Max Download Rate per Torrent
$cfg["max_download_rate"] = 0; // KB/second max download rate per torrent (0 for no limit)

// --max_uploads - Set the Default Value for the Max number of Upload connections per Torrent
$cfg["max_uploads"] = "4"; // BitTorrent default is 7

// -- minport - Set the Default Value for the minport (for port range)
$cfg["minport"] = "49160"; // BitTorrent default is 6881

// --maxport - Set the Default Value for the maxport (for port range)
$cfg["maxport"] = "49300"; // BitTorrent default is 6999

// Extra Commandline options for btphpdownload if you want to override the defaults for BitTorrent
// View the download.py script in the BitTorrent scripts for more options
// DO NOT include --max_upload_rate, --minport, --maxport, --max_uploads here,
// it is included by TorrentFlux.  See items above.
$cfg["cmd_options"] = "";

// Enable the Suprnova.org Search Form on Home Page
$cfg["enable_search"] = true;

// Enable users to download files from the directory browsing
$cfg["enable_file_download"] = true;

// Use "tar" or "zip" for directory downloading (if you use zip make sure it is installed)
$cfg["package_type"] = "tar";

// Enable showing the average server load over the last 15 minutes from /proc/loadavg file
$cfg["show_server_load"] = true;

// The path to your loadavg file
$cfg["loadavg_path"] = "/proc/loadavg";

// days to keep audit actions in DB. (owner ship of torrent based on this)
$cfg['days_to_keep'] = 30;

// minutes to keep user online status.
$cfg['minutes_to_keep'] = 3;

$cfg["rss_cache_min"] = 20;  // minutes to cache RSS Feeds

$cfg["page_refresh"] = "60";  // number of seconds before the page will refresh

// default theme
$cfg["default_theme"] = "matrix";

// default language file -- check the language folder for your language
// if you want to contribute a language file email qrome@yahoo.com
$cfg["default_language"] = "lang-english.php";

// Email Options
$cfg["use_email"] = false;
$cfg["adminemail"] = "nobody@home.com";

// Restrict torrent file size for upload
$cfg["max_upload"] = 1000000;  // 1000000 is 1MB
$cfg["min_upload"] = 0;

// Show Debug SQL statements on SQL Errors (true/false)
// Errors will always display but not the SQL Statement
// by setting to true, you will see the SQL statement displayed
$cfg["debug_sql"] = false;

// Add file extensions here that you will allow to be uploaded
$cfg["file_types_array"] = array("torrent");

// Do you want the BitTorrent to shutdown when download is complete?
// Please keep your torrents open!
// Must be "True" or "False" -- Case sensative
$cfg["torrent_dies_when_done"] = "False";

// Set the default share pecentage where torrents will shutoff
// when running torrents that do not die when done
// Value '0' will seed forever.  The value of 'sharekill' is
// ignored when $cfg["torrent_dies_when_done"] = "True"
$cfg["sharekill"] = "150";

// Defualt value for hiding offline users on home page
// Can be set per user in their profile
$cfg["hide_offline"] = false;


/*****************************************************************************
	TorrentFlux
	Torrent (n.) A violent or rapid flow; a strong current; a flood;
	        as, a torrent vices; a torrent of eloquence.
	Flux    (n.) The act of flowing; a continuous moving on or passing by,
	        as of a flowing stream; constant succession; change.
*****************************************************************************/



// ***************************************************************************
// ***************************************************************************
// DO NOT Edit below this line unless you know what you're doing.
// ***************************************************************************
// ***************************************************************************

$cfg["pagetitle"] = "TorrentFlux";

// TorrentFlux Version
$cfg["version"] = "2.0 beta";

// CONSTANTS
$cfg["constants"] = array();
$cfg["constants"]["url_upload"] = "URL Upload";
$cfg["constants"]["start_torrent"] = "Started Torrent";
$cfg["constants"]["access_denied"] = "ACCESS DENIED";
$cfg["constants"]["delete_torrent"] = "Delete Torrent";
$cfg["constants"]["fm_delete"] = "File Manager Delete";
$cfg["constants"]["fm_download"] = "File Download";
$cfg["constants"]["kill_torrent"] = "Kill Torrent";
$cfg["constants"]["file_upload"] = "File Upload";
$cfg["constants"]["error"] = "ERROR";
$cfg["constants"]["hit"] = "HIT";
$cfg["constants"]["update"] = "UPDATE";
$cfg["constants"]["admin"] = "ADMIN";

asort($cfg["constants"]);


// Capture username
$cfg["user"] = "";
$cfg["password"] = "";
// Capture ip
$cfg["ip"] = $_SERVER['REMOTE_ADDR'];

$cfg["theme"] = $cfg["default_theme"];

$cfg["language_file"] = $cfg["default_language"];

// Total bandwidth
$cfg["total_upload"] = 0;
$cfg["total_download"] = 0;

// Free space in MB
$cfg["free_space"] = disk_free_space($cfg["path"])/(1024*1024);

// Path to where the torrent meta files will be stored... usually a sub of $cfg["path"]
// also, not the '.' to make this a hiddent directory
$cfg["torrent_file_path"] = $cfg["path"].".torrents/";

// Register Globals for those that don't have it set to on
if (!ini_get("register_globals"))
{
    import_request_variables('GPC');
}

?>
