/* 
Run this as the torrentflux user.

Example:
psql -d torrentflux torrentfluxuser -p -f filename.sql
*/

CREATE SEQUENCE tf_links_sequence START 1;

CREATE TABLE tf_links (
  lid integer PRIMARY KEY DEFAULT nextval('tf_links_sequence'),
  url varchar(255) NOT NULL DEFAULT ''
);

/* data */

INSERT INTO tf_links VALUES (1, 'http://www.suprnova.org');
INSERT INTO tf_links VALUES (2, 'http://www.torrentbits.org');
INSERT INTO tf_links VALUES (3, 'http://varchars.com/rss/');
INSERT INTO tf_links VALUES (4, 'http://www.litezone.com');
INSERT INTO tf_links VALUES (5, 'http://www.torrentflux.com');
INSERT INTO tf_links VALUES (6, 'http://www.imdb.com');

/* -------------------------------------------------------- */


/* Table structure for table `tf_log` */

CREATE SEQUENCE tf_log_sequence START 1;

CREATE TABLE tf_log (
  cid integer PRIMARY KEY DEFAULT nextval('tf_log_sequence'),
  user_id varchar(32) NOT NULL DEFAULT '',
  file varchar(200) NOT NULL DEFAULT '',
  action varchar(200) NOT NULL DEFAULT '',
  ip varchar(15) NOT NULL DEFAULT '',
  ip_resolved varchar(200) NOT NULL DEFAULT '',
  user_agent varchar(200) NOT NULL DEFAULT '',
  time varchar(14) NOT NULL DEFAULT '0'
);


/* Table structure for table `tf_messages` */

CREATE SEQUENCE tf_messages_sequence START 1;

-- column 'new' is now 'IsNew'
CREATE TABLE tf_messages (
  mid integer PRIMARY KEY default nextval('tf_messages_sequence'),
  to_user varchar(32) NOT NULL default '',
  from_user varchar(32) NOT NULL default '',
  message text,
  IsNew integer NOT NULL default '1',
  ip varchar(15) NOT NULL default '',
  time varchar(14) NOT NULL default '0',
  force_read smallint default '0'
);


/* Table structure for table `tf_rss` */

CREATE SEQUENCE tf_rss_sequence START 1;

CREATE TABLE tf_rss (
  rid integer PRIMARY KEY default nextval('tf_rss_sequence'),
  url varchar(255) NOT NULL default ''
);

/* Dumping data for table `tf_rss` */

INSERT INTO tf_rss VALUES (1, 'http://www.tvtorrents.net/rss.php');
INSERT INTO tf_rss VALUES (2, 'http://btefnet.com/backend.php');
INSERT INTO tf_rss VALUES (3, 'http://varchars.com/rss/suprnova-tv.rss');
/* -------------------------------------------------------- */

/* Table structure for table `tf_users` */

CREATE SEQUENCE tf_users_sequence START 1;
CREATE TABLE tf_users (
  uid integer PRIMARY KEY default nextval('tf_users_sequence'),
  user_id varchar(32) NOT NULL default '',
  password varchar(34) NOT NULL default '',
  hits integer NOT NULL default '0',
  last_visit varchar(14) NOT NULL default '0',
  time_created varchar(14) NOT NULL default '0',
  user_level smallint NOT NULL default '0',
  hide_offline smallint NOT NULL default '0',
  theme varchar(100) NOT NULL default 'mint',
  language_file varchar(60) default 'lang-english.php'
);

